	.CR	SCMP
	.TF	CHARSET.HEX,INT
	.LF	CHARSET.LST
; *****************************************************************************
; Version of Charset demo from SoC VDU Manual to show whole
;
; Typed in for SBASM by T.Gilberts June 2020
;
; This routine requires the RAM-I/O chip and Extra RAM to be fitted.
; It blanks the screen and displays all the character set plus the original
; animation.
;
; *****************************************************************************

	.OR	0x0880

ENTER:				;As we are using 8154 we need to set Character mode
	LDI	0x08
	XPAH	P2
	LDI	0x00
	XPAL	P2
	LDI	0xFD
	ST	0x22(P2)	;Turn on ALL 8 Port A as Outputs
;Setup the bits	
;	ST	0x17(P2)	;Enable White on Black Video - no back porch makes white bad...
;	ST	0x06(P2)	;Text Mode (default anyway as are zero)
;	ST	0x15(P2)	;(b12) PS4=1
;	ST	0x14(P2)	;(b9)  PS1=0
;	ST	0x13(P2)	;ReversePages=1 - So F00 is above B00
;	ST	0x12(P2)	;(b10) PS2=1
;	ST	0x11(P2)	;(b11) PS3=1 (likely not needed as will be strapped to TopPage)
;	ST	0x00(P2)	;When Output LOW - Turn on VideoCard (if using 8154 control)
;All of the above can be one write to 0x0820...	10111110 = 0xBE (above is useful as it is how
;the data sheet of the 8154 suggests using the chip to set and reset individual bits for control
;purposes.  You can also read those bits as they show up on Bit 7...
	LDI	0xBE
	ST	0x20(P2)
	
	LDI	0x00		;or lower FLAG2 for other card designs
	CAS		

SHOWCH:	LDI	0x0B		; clear page 0xB00

S0:	XPAH	P1
	
S1:	LDI	0x00

S2:	XPAL	P1
	LDI	0x20
	ST	@1(P1)
	XPAL	P1
	JNZ	S2
	XPAH	P1

S3:	XPAL	P1
	LDI	0x4B
	XPAH	P1
	LDI	0x43
	ST	22(P1)		; We go a line lower than the manual in case
	LDI	0x48
	ST	23(P1)		; reverse pages is not working / connected
	LDI	0x41
	ST	24(P1)		; so you can still see the top line
	LDI	0x52
	ST	25(P1)
	LDI	0x7D
	ST	26(P1)
	LDI	0x60
	ST	28(P1)		; Turn inverse back off after the character
S4:	ILD	NEXTCHR-$-1(P0)	; Remember the SC/MP is already looking at the next address...
	ORI	#0x40		; Set bit 6 so inverse
	ST	27(P1)
	DLY	0xFF
	JMP	S4

NEXTCHR:
 	.DB	0x00

MESSAGE:

	.OR	0x0F12
	
	.DB	20h,20h,20h,54h,49h,4Dh,42h,55h,43h,55h,53h,60h,20h,20h
	.DB	2Dh,2Dh,2Dh,2Dh,2Dh,2Dh,2Dh,2Dh,2Dh,2Dh,2Dh,2Dh,2Dh,2Dh,2Dh,2Dh
	.DB	00h,01h,02h,03h,04h,05h,06h,07h,08h,09h,0Ah,0Bh,0Ch,0Dh,0Eh,0Fh
	.DB	20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h
	.DB	10h,11h,12h,13h,14h,15h,16h,17h,18h,19h,1Ah,1Bh,1Ch,1Dh,1Eh,1Fh
	.DB	20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h
	.DB  	20h,21h,22h,23h,24h,25h,26h,27h,28h,29h,2Ah,2Bh,2Ch,2Dh,2Eh,2Fh
	.DB	20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h
	.DB	30h,31h,32h,33h,34h,35h,36h,37h,38h,39h,3Ah,3Bh,3Ch,3Dh,3Eh,3Fh
	.DB	20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h
	.DB	20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h
	.DB	20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h
	.DB	20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h
	.DB	20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h,20h
	
;Support SH PI-Progammer Auto Start

	.OR 0xFFFE
	.DB ENTER/256
	.DB ENTER&255
	
	.EN
